import greenfoot.*;  // (World, Actor, GreenfootImage, and Greenfoot)
import java.util.ArrayList;

/**
 * Write a description of class MyWorld here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MyWorld extends World
{
    static private final int NETWIDTH = 7;
    static private final int NETHEIGHT = 7;
    static private final int NETSPACING = 30;
    
    private ArrayList<Edge> edges;

    /**
     * Constructor for objects of class MyWorld.
     * 
     */
    public MyWorld()
    {    
        super(500, 500, 1);
        setActOrder(Node.class, Edge.class);
        setPaintOrder(Node.class, Edge.class);
        createNet();
    }
    
    public void act() 
    {
        //System.out.println("world act");
        for (Edge edge : edges) {
            edge.applyForce();
        }
    }

    private void createNet() 
    {
        edges = new ArrayList<Edge>();
        Node[][] net = createNodes();
        addNodesToWorld(net);
        addEdges(net, edges);
        net[0][0].pin();
        net[NETWIDTH-1][0].pin();
    }

    private Node[][] createNodes() 
    {
        Node[][] net = new Node[NETWIDTH][NETHEIGHT];
        for (int x = 0; x < NETWIDTH; x++) {
            for (int y = 0; y < NETHEIGHT; y++) {
                net[x][y] = new Node();
            }
        }
        return net;
    }
    
    private void addNodesToWorld(Node[][] net) 
    {
        for (int x = 0; x < NETWIDTH; x++) {
            for (int y = 0; y < NETHEIGHT; y++) {
                addObject(net[x][y], x*30 + 160, y*30 + 100);
            }
        }
    }

    private void addEdges(Node[][] net, ArrayList<Edge> edges) 
    {
        Edge edge;
        
        for (int x = 0; x < NETWIDTH; x++) {
            for (int y = 0; y < NETHEIGHT; y++) {
                if (x > 0) {
                    edge = new Edge(net[x-1][y], net[x][y], NETSPACING);
                    edges.add(edge);
                    addObject(edge, 0, 0);
                }
                if (y > 0) {
                    edge = new Edge(net[x][y-1], net[x][y], NETSPACING);
                    edges.add(edge);
                    addObject(edge, 0, 0);
                }
            }
        }
    }

}
